/*
 * Replacer - program that replaces one string with other in whole ile
 * Version: 1.0
 * Author: Piotr 'Deletek' Kupisiewicz <deli@rzepaknet.us>
 */
	     
    
#include <stdio.h>
#include <string.h>

#define MAXLINE 2048

void help(void)
{
	printf("Use: \n");
	printf("replacer <source_file> <destination_file> <string_to_find> <string_to_replace>\n\n");
	printf("Piotr 'Deletek' Kupisiewicz <deli@rzepaknet.us>\n");
}

int strpos(const char *s1, const char *s2)
{
	return strlen(s1) - strlen(strstr(s1, s2));
}

int main(int argc, char *argv[])
{
	FILE *in;
	FILE *out;
	char buffer[MAXLINE];
	char tmp[MAXLINE];
	int i;
	
	if(argc != 5)
	{
		help();
		exit(1);
	}
	
	in = fopen(argv[1], "r");
	if(in == NULL)
	{
		printf("Couldn't open the file %s\n", argv[1]);
		exit(1);
	}
	out = fopen(argv[2], "w");
	if(out == NULL)
	{
		printf("Couldn't open the file %s for writting\n", argv[2]);
		exit(1);
	}
	while(!feof(in))
	{	
		fgets(buffer, MAXLINE - 1, in);
		if(strstr(buffer, argv[3]))
		{	
			i = strpos(buffer, argv[3]);
			strncpy(tmp, buffer, i);
			fprintf(out, "%s%s", tmp, argv[4]);
			for(i= i + strlen(argv[3]); i < strlen(buffer); i++)
			{	
				fprintf(out, "%c", buffer[i]);
			}
			
		}
		else
			fprintf(out, "%s", buffer);
	}
	fclose(in);
	fclose(out);
	return 0;
}
